#!/usr/bin/env python
# -*- coding: utf-8 -*-

from pyModbusTCP.client import ModbusClient
import time
import datetime

#diagslave-server
SERVER_HOST = "192.168.15.194"
SERVER_PORT = 502

c = ModbusClient()

# uncomment this line to see debug message
c.debug(True)
xwert = 200

# define modbus server host, port
c.host(SERVER_HOST)
c.port(SERVER_PORT)
print("define modbus  "+SERVER_HOST+":"+str(SERVER_PORT))

while True:
    ts = time.time()
    st = datetime.datetime.fromtimestamp(ts).strftime('%d%m%Y')
    sfi= datetime.datetime.fromtimestamp(ts).strftime('%Y-%m-%d %H:%M:%S')
    fn = "UVR610S_MODBUS_"+st
    if not c.is_open():
        print(" not c.is_open or reconnect    "+SERVER_HOST+":"+str(SERVER_PORT))
        if not c.open():
            print("unable to connect to "+SERVER_HOST+":"+str(SERVER_PORT))

    # if open() is ok, read register (modbus function 0x03)
    if c.is_open():
        print("is open --> to connect to "+SERVER_HOST+":"+str(SERVER_PORT))
        if  c.write_single_register(111, xwert): 
                print(" write ok ")
        else:
                print(" write error")
        
        regs = c.read_holding_registers(111, 4)
        if regs:
           print(sfi+" reg ad #110-111: "+str(regs))
           afzeile = sfi+" reg ad #110-111: "+str(regs)+"\n"
           fout=open(fn,"a+")
           fout.write(afzeile)
           fout.close()

    # sleep 2s before next polling
    xwert = xwert+2
    time.sleep(2)


